=== debian/changelog ===
jackd2 (1.9.16~dfsg-1) unstable; urgency=medium

  * Team upload
  * New upstream release
  * debian/copyright:
    - Fix pattern in Files-Excluded
    - Update paths of moved files

 -- Sebastian Ramacher <sramacher@debian.org>  Sun, 18 Oct 2020 16:56:14 +0200

jackd2 (1.9.14~dfsg-1) unstable; urgency=medium

  * Team upload

  [ Sebastian Ramacher ]
  * debian/control:
    - Remove obsolete Pre-Depends
    - Remove d-shlibs from B-Ds
    - Add libsystemd-dev to B-Ds to build with sd_notify support
    - Remove unused asound:Depends
  * debian/copyright: Remove waf from Files-Excluded (Closes: #884082)
  * debian/jackd2.maintscript: Update maintscript to remove old conffiles
    (Closes: #726079)
  * debian/audio.conf: Fix command (Closes: #951432)

  [ Jonas Smedegaard ]
  * remove myelf as uploader

 -- Sebastian Ramacher <sramacher@debian.org>  Mon, 24 Aug 2020 21:13:05 +0200

jackd2 (1.9.14~dfsg-0.1) unstable; urgency=medium

  [ Ondřej Nový ]
  * d/control: Remove trailing whitespaces

  [ Felipe Sateler ]
  * Change maintainer address to debian-multimedia@lists.debian.org

  [ Ondřej Nový ]
  * Use debhelper-compat instead of debian/compat

  [ Olivier Humbert ]
  * d/control: http -> https
  * d/control.in: http -> https
  * d/copyright: http -> https

  [ Ross Gammon ]
  * New upstream version 1.9.14
  * Add a gitlab-ci.yml file
  * Fix name of gilab-ci file
  * Update watch file to use repack suffix in downloaded tarball
  * New upstream version 1.9.14~dfsg
  * Unapply patches from source
  * Refresh patches & drop the one applied upstream
  * Add pyc files to clean target

  [ Erich Eickmeyer ]
  * Change compat level to 10, add back compat file

  [ Sandro Tosi ]
  * NMU
  * Switch to python3; Closes: #936757, #959177

 -- Sandro Tosi <morph@debian.org>  Thu, 09 Jul 2020 00:07:53 -0400
